var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
define(["require", "exports", "system_lib/Script", "system/SimpleFile", "system_lib/Metadata", "system/WebRenderer"], function (require, exports, Script_1, SimpleFile_1, Metadata_1, WebRenderer_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var CustomWebPageCommunicator = (function (_super) {
        __extends(CustomWebPageCommunicator, _super);
        function CustomWebPageCommunicator(env) {
            var _this = _super.call(this, env) || this;
            _this.establishChannel("append-to-file", function (data) {
                var appendToFileData = JSON.parse(data);
                return _this.doAppendTextToFile(appendToFileData);
            });
            console.log('CustomWebPageCommunicator started');
            return _this;
        }
        CustomWebPageCommunicator.prototype.doAppendTextToFile = function (appendData) {
            SimpleFile_1.SimpleFile.append(appendData.fileName, appendData.text + '\n');
        };
        CustomWebPageCommunicator.prototype.generateQRImage = function (data) {
            var IMAGE_NAME = "qr.png";
            return new Promise(function (resolve, reject) {
                WebRenderer_1.WebRenderer.render(CustomWebPageCommunicator.IMAGE_URL + data.qrContent, IMAGE_NAME, 250, 250).then(function () {
                    return SimpleFile_1.SimpleFile.move("/public/WebRenderer/" + IMAGE_NAME, CustomWebPageCommunicator.CUSTOM_IMAGE_DIR + IMAGE_NAME, true);
                }).then(function () {
                    resolve(CustomWebPageCommunicator.CUSTOM_IMAGE_DIR + IMAGE_NAME);
                }).catch(function (error) {
                    console.error("generateQRImage failed", error);
                    reject(error);
                });
            });
        };
        return CustomWebPageCommunicator;
    }(Script_1.Script));
    CustomWebPageCommunicator.IMAGE_URL = "https://chart.googleapis.com/chart?cht=qr&chs=250x250&chl=";
    CustomWebPageCommunicator.CUSTOM_IMAGE_DIR = "/public/custom/";
    __decorate([
        Metadata_1.resource(),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object]),
        __metadata("design:returntype", Promise)
    ], CustomWebPageCommunicator.prototype, "generateQRImage", null);
    exports.CustomWebPageCommunicator = CustomWebPageCommunicator;
});
